/// Reference a video channel via an Asset's data scope
#[derive(
    Debug,
    Clone,
    conjure_object::serde::Serialize,
    conjure_object::serde::Deserialize,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash
)]
#[serde(crate = "conjure_object::serde")]
#[conjure_object::private::staged_builder::staged_builder]
#[builder(crate = conjure_object::private::staged_builder, update, inline)]
pub struct VideoAssetChannel {
    #[builder(into)]
    #[serde(rename = "assetRid")]
    asset_rid: String,
    #[builder(into)]
    #[serde(rename = "dataScopeName")]
    data_scope_name: String,
    #[builder(into)]
    #[serde(rename = "channel")]
    channel: String,
    #[builder(default, map(key(type = String, into), value(type = String, into)))]
    #[serde(
        rename = "tags",
        skip_serializing_if = "std::collections::BTreeMap::is_empty",
        default
    )]
    tags: std::collections::BTreeMap<String, String>,
}
impl VideoAssetChannel {
    /// Constructs a new instance of the type.
    #[inline]
    pub fn new(
        asset_rid: impl Into<String>,
        data_scope_name: impl Into<String>,
        channel: impl Into<String>,
    ) -> Self {
        Self::builder()
            .asset_rid(asset_rid)
            .data_scope_name(data_scope_name)
            .channel(channel)
            .build()
    }
    #[inline]
    pub fn asset_rid(&self) -> &str {
        &*self.asset_rid
    }
    #[inline]
    pub fn data_scope_name(&self) -> &str {
        &*self.data_scope_name
    }
    #[inline]
    pub fn channel(&self) -> &str {
        &*self.channel
    }
    #[inline]
    pub fn tags(&self) -> &std::collections::BTreeMap<String, String> {
        &self.tags
    }
}
